//BePexesoApp.h
#ifndef BE_PEXESO_APP_H
#define BE_PEXESO_APP_H

#include <Application.h>
#include <Directory.h>
#include <MenuItem.h>
#include <assert.h>
#include <Path.h>
#include <Menu.h>
#include <Alert.h>
#include <stdio.h>
#include <string.h>
#include "BePexesoGame.h"
#include "BePexesoWin.h"
#include "data.h"
#include "common.h"

#define TILE_BACK_RGB "TileBack.rgb"
#define BACKGROUND_RGB "Background.rgb"

class BePexesoApp : public BApplication
{
 public: 
 	BePexesoApp();
 	void ReadyToRun(void);
 	void AboutRequested();
 	bool QuitRequested();
 	BMenu* GetTilesetsMenu();
 	BePexesoGame* game;
 	BePexesoWin *mw;
 private:
 	thread_id gameTID;
 	bool texturesFound;
  	bool LoadTilesets(void );
  	void LoadTextures(void);
 	BMenu* tilesetMenu;
};

#endif //BE_PEXESO_APP_H
