//BePexesoView.h
#ifndef BE_PEXESSO_VIEW_H
#define BE_PEXESSO_VIEW_H

#include <InterfaceKit.h>
#include <SupportDefs.h>
#include <GLView.h>
#include <View.h>
#include "data.h"

/* the tiles are at z = DEPTH */
#define DEPTH -6.0

class BePexesoView : public BGLView
{
  public:
	BePexesoView(BRect R);
	~BePexesoView();
	void InitDisplay(int width, int height);
  	void AllocTextureNames();
  	void LoadTilesetTexture(void);
  	void RenderFrame(void );
  	void MouseDown(BPoint where);
  	void MouseMoved(BPoint point, uint32 transit, const BMessage *message);
  private:
    int PickTile(int scrx, int scry, int& rx, int& ry);
    void RenderTile(Tile *pTile);
    void DrawTileFace(int);
  	void DrawTileBack();
  	void RenderBackground();
  	
	/* ID of display list for back of tile */
	GLuint nTileBackList;
	/* centers of texture face images */
	GLfloat fTexCent[32][2];
	GLint viewport[4];
};
#endif //BE_PEXESSO_VIEW_H
