//BePexesoWin.cpp

#include "BePexesoWin.h"
#include "BePexesoApp.h"

BePexesoWin::BePexesoWin()
	: BDirectWindow(BRect(100,100,365,365), "BePexeso", B_TITLED_WINDOW, 0, 0)
{
	mb = BuildMenu();
	AddChild(mb);
	
	BRect r = Bounds();
	r.top = r.top + 20;
	
	mv = new BePexesoView(r);
	AddChild(mv);

	mv->EnableDirectMode(true);
}

BePexesoWin::~BePexesoWin()
{
}

BMenuBar* BePexesoWin::BuildMenu()
{
	BMenuBar *menuBar = new BMenuBar(BRect(0,0,512,20), "menubar");
	
	BMenu *newGame = new BMenu("New Game", B_ITEMS_IN_COLUMN);
	BMenuItem *small = new BMenuItem("Small (5x4)", new BMessage(MSG_NEW_SMALL_GAME), 'n');
	BMenuItem *medium = new BMenuItem("Medium (6x6)", new BMessage(MSG_NEW_MEDIUM_GAME), 'm');
	BMenuItem *large = new BMenuItem("Large (8x8)", new BMessage(MSG_NEW_LARGE_GAME), 'l');
	newGame->AddItem(small);
	newGame->AddItem(medium);
	newGame->AddItem(large);
	menuBar->AddItem(newGame);
	
	BMenu *options = new BMenu("Options", B_ITEMS_IN_COLUMN);
	BMenuItem *spotLight = new BMenuItem("Spotlight", new BMessage(MSG_OPTIONS_SPOTLIGHT), 's');
	BMenuItem *waves = new BMenuItem("Wavy Surface", new BMessage(MSG_OPTIONS_WAVES), 'w');
	options->AddItem(spotLight);
	options->AddItem(waves);
	menuBar->AddItem(options);
	tilesetMenu = ((BePexesoApp *)be_app)->GetTilesetsMenu();
	menuBar->AddItem( tilesetMenu );
	
	BMenuItem *pexesoMark = new BMenuItem("PexesoMark", new BMessage(B_ABOUT_REQUESTED));
	pexesoMark->SetTarget(be_app);
	menuBar->AddItem(pexesoMark);
	
	return menuBar;
}

void BePexesoWin::DirectConnected(direct_buffer_info *info)
{
	mv->DirectConnected(info);
}

void
BePexesoWin::MessageReceived(BMessage *msg)
{
	BMenuItem *item;
	switch(msg->what)
	{
		//mouse moved
		//mouse down
		case MSG_NEW_SMALL_GAME:
		{
			//(new BAlert("New Game","New Small Game", "OK"))->Go();
			nTilesX = 5;
			nTilesY = 4;
			((BePexesoApp *)be_app)->game->InitGame();
			mv->InitDisplay(xVP, yVP);
			break;
		}
		case MSG_NEW_MEDIUM_GAME:
		{
			//(new BAlert("New Game","New Medium Game", "OK"))->Go();
			nTilesX = 6;
			nTilesY = 6;
			((BePexesoApp *)be_app)->game->InitGame();
			mv->InitDisplay(xVP, yVP);
			break;
		}
		case MSG_NEW_LARGE_GAME:
		{
			//(new BAlert("New Game","New Large Game", "OK"))->Go();
			nTilesX = 8;
			nTilesY = 8;
			((BePexesoApp *)be_app)->game->InitGame();
			mv->InitDisplay(xVP, yVP);
			break;
		}
		case MSG_OPTIONS_SPOTLIGHT:
		{
			item = mb->FindItem("Spotlight");
			bSpotlight = !bSpotlight;
			item->SetMarked(bSpotlight);
			mv->InitDisplay(xVP, yVP);
			break;
		}
		case MSG_OPTIONS_WAVES:
		{
			item = mb->FindItem("Wavy Surface");
			bWaves = !bWaves;
			item->SetMarked(bWaves);
			
			int x,y;
			for(y=0; y<nTilesY; y++)
			{
				for(x=0; x<nTilesX; x++)
				{
					tiles[y][x].xRot.x = 0.0f;
					tiles[y][x].xRot.v = 0.0f;
					tiles[y][x].yRot.x = 0.0f;
					tiles[y][x].yRot.v = 0.0f;
				}
			}
			break;
		}
		case MSG_CHANGE_TILESET:
		{
			BMenuItem *ts = tilesetMenu->FindMarked();
			for (int i=0; i<nTilesets; i++)
			{
				if (! strcmp( chTilesets[i], ts->Label()) )
				{
					dwCurrentTS = i;
					strcpy(chCurrentTS, ts->Label());
					mv->LoadTilesetTexture();
				}
			}
			//(new BAlert("Change Tileset", ts->Label(), "OK"))->Go();
			break;
		}
		default:
			BWindow::MessageReceived(msg);
	}	
}

bool
BePexesoWin::QuitRequested()
{
	((BePexesoApp *)be_app)->game->bQuit = true;
	be_app->PostMessage(B_QUIT_REQUESTED);
	return true;
}

void
BePexesoWin::WindowActivated(bool active)
{
	if ( active ){
		bForeground = true;
		dwFrameLimit = 0;
	}else{
		dwFrameLimit = 200;
		bForeground = false;
	}
}

void
BePexesoWin::FrameResized(float width, float height)
{
	xVP=width;
	yVP=height-20;
	mv->InitDisplay(xVP,yVP);
}