/*
  'Extern' declarations for all data of global importance
*/

#if !defined(__data)

#define __data

#include <OS.h>
#include <GL/gl.h>
#include <GL/glu.h>
#include <stdlib.h>
#include <assert.h>
#include <stdio.h>

#define MAXTILES 10  /* maximum number of tiles in both directions */

extern int dwFrames;
extern bigtime_t dwElapsed, dwStart;

extern unsigned char 
  *pTileTexture, /* texture for the tile piece itself */
  *pBackTexture, /* texture for the background */ 
  *pTileset;     /* 32 textures for tile faces */ 

extern int nTilesX, nTilesY, 
  nTypes, /* number of different tile types (== pictures) */
  nOpen,  /* number of open tiles */
  nOff;   /* number of tiles taken off the board, sorry, jelly */
  
extern int nXTileDown, nYTileDown;

typedef struct tagTile {
  int nType;
  GLfloat fX, fY; 
  int nState, nNextState, nTransType;
  float fProgress; /* for keeping constant animation speed */

  // ugh, dynamics
  struct {
    GLfloat x, v;  // pos & speed vectors
  } xRot, yRot, xNextRot, yNextRot;
} Tile;

extern Tile tiles[MAXTILES][MAXTILES];

extern float xMousePos, yMousePos;

extern bool bSpotlight, bWaves;

extern float xVP, yVP;

#define TILETEX 0
#define BACKTEX 1
#define TILESET 2

extern GLuint texNames[3];

extern int dwFrameLimit;

#define MAXTILESETS 32

extern int nTilesets;
extern char chTilesets[MAXTILESETS][256];
extern int dwCurrentTS;
extern char chCurrentTS[256];

extern char chExePath[256];

extern bool bPexesoMark;

extern bool bForeground;

extern const char *glVersion, *glRenderer, *glVendor; 

#endif
